<?php

/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modelform');
require_once JPATH_COMPONENT . '/helpers/expparams.php';
require_once JPATH_COMPONENT . '/helpers/expfields.php';
require_once JPATH_COMPONENT . '/helpers/helper.php';

class ExpAutosProModelExpImport extends JModelForm {

    protected $data;

    public function checkin($userId = null) {
        $userId = (!empty($userId)) ? $userId : (int) $this->getState('expuser.id');
//$table = JTable::getInstance('Expuser', $prefix = 'ExpautosproTable');
        return true;
    }

    function getExpparams() {
        $expparams = ExpAutosProExpparams::getExpParams('config', 1);
        return $expparams;
    }

    function getExpgroup() {
        $user = JFactory::getUser();
        $UserId = (int) $user->get('id');
        $listusergroup = '';
        if ($UserId > 0) {
//$listusergroups = implode(',', JAccess::getGroupsByUser($UserId));
            $listusergroups = implode(',', JAccess::getGroupsByUser($UserId));
            $listusergroup = ExpAutosProExpparams::getExpgroupname($listusergroups);
        }
        return $listusergroup;
    }

    function getExpgroupid() {
        $user = JFactory::getUser();
        $UserId = (int) $user->id;
        $usergroupid = '';
        if ($UserId > 0) {
            $usergroups = implode(',', $user->groups);
            $usergroupid = ExpAutosProExpparams::getExpgroupid($usergroups);
        }
        return $usergroupid;
    }

    function getExpgroupfields() {
        $user = JFactory::getUser();
        $UserId = (int) $user->get('id');
        $listgroupparams = '';
        if ($UserId > 0) {
//$listusergroups = implode(',', $user->groups);
            $listusergroups = implode(',', JAccess::getGroupsByUser($UserId));
            $listusergroupid = ExpAutosProExpparams::getExpgroupid($listusergroups);
            $listgroupparams = ExpAutosProExpparams::getExpParams('userlevel', $listusergroupid);
        }
        return $listgroupparams;
    }

    function getExpcategoryfields($data) {
        $listcatfields = ExpAutosProExpparams::getCatParams($data);
        return $listcatfields;
    }

    protected function populateState() {
        
    }

    public function getData() {
        
    }

    public function getForm($data = array(), $loadData = true) {
// Get the form.
        $form = $this->loadForm('com_expautospro.expimport', 'expimport', array('control' => 'jform', 'load_data' => $loadData));
        if (empty($form)) {
            return false;
        }

        return $form;
    }

    protected function loadFormData() {
        return $this->getData();
    }

    public function expvalid($data) {

        return true;
    }

    public function saveimg($logo_data, $data_user, $width, $height, $sep = 5) {
        
    }

    public function save($data) {
        
    }

    public function importxml($uploadfile) {
        $app = JFactory::getApplication();
        $expparams = $this->getExpparams();
        if ($uploadfile['size'] > $expparams->get('c_admanager_importxml_maxfilesize', 0)) {
            $app->enqueueMessage(JText::_(JText::sprintf('COM_EXPAUTOSPRO_IMPORTXML_ERROR_PROBLEM_FILESIZE_TEXT', ExpAutosProFields::exp_convertsize($uploadfile['size']), ExpAutosProFields::exp_convertsize($expparams->get('c_admanager_importxml_maxfilesize', 0)))), 'warning');
            return false;
        }
        $user = JFactory::getUser();
        $userId = (int) $user->get('id');
        $expreqfield = ExpAutosProExpparams::getExpDealersParams($userId);
        $zippatch = null;
        $zipname = null;
        $zipfolder = null;
        if ($expreqfield->get('g_expimport')) {
            $db = JFactory::getDBO();
            $fname = $uploadfile['name'];
            $chk_ext = explode(".", $fname);
            $req = 1;
            $expallowext = $expparams->get('c_admanager_importxml_allowedext', 'xml,zip');
            $expallowext = explode(",", $expallowext);
            if (in_array(strtolower($chk_ext[1]), $expallowext)) {
                if (strtolower($chk_ext[1]) == "xml") {
                    $isxml = true;
                } else {
                    $isxml = false;
                }
                if ($isxml) {
                    $xml = simplexml_load_file($uploadfile['tmp_name']);
                } else {
                    $ziparchive = $this->_getPackageFromUpload($uploadfile);
                    if ($ziparchive) {
                        $zippatch = $ziparchive['folder'] . "/" . $ziparchive['file'];
                        $zipname = $ziparchive['zipname'];
                        $zipfolder = $ziparchive['folder'];
                        $xml = simplexml_load_file($zippatch);
                    }
                }
                if ($xml) {
                    $xmlchild = $xml->children();
                    $countad = count($xmlchild);
                    $count_limit = $expreqfield->get('g_adscount');
                    if ($count_limit) {
                        $count_ads = ExpAutosProHelper::getExpcount('admanager', 'user', $userId, 0);
                        $count_limit_num = $count_limit - $count_ads;
                        if (($count_limit_num > 0) && (($count_limit_num - $countad) < 0)) {
                            $countad = $countad - $count_limit_num;
                        } elseif ($count_limit_num <= 0) {
                            $countad = 0;
                            $app->enqueueMessage(JText::sprintf(JText::_('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_LIMITADS_TEXT'), $count_limit), 'warning');
                        }
                    }
                    $obj = new stdClass();
                    for ($i = 0; $i < $countad; $i++) {
                        $obj->catid = $this->expcheckdb('categories', (string) $xmlchild[$i]->catid, 'title', 'published', 1, 1, 1);
                        $expcatfields = null;
                        $obj->user = $userId;
                        if (is_numeric($obj->catid)) {
                            $expcatfields = $this->getExpcategoryfields((int) $obj->catid);
                        }
                        if ($expcatfields) {
                            if ($expcatfields->get('usemakes')) {
                                $obj->make = $this->expcheckdb('expautos_make', (string) $xmlchild[$i]->make, 'name', 'state', $expparams->get('c_admanager_req_makes'), 1, 0, 'catid = ' . $obj->catid);
                            }
                            if ($expcatfields->get('usemodels') && $obj->make) {
                                $obj->model = $this->expcheckdb('expautos_model', (string) $xmlchild[$i]->model, 'name', 'state', $expparams->get('c_admanager_req_models'), 1, 0, 'makeid = ' . $obj->make);
                            }
                            if ($expcatfields->get('usecountry')) {
                                $obj->country = $this->expcheckdb('expautos_country', (string) $xmlchild[$i]->country, 'name', 'state', $expparams->get('c_admanager_req_country'), 1, 0);
                            }
                            if ($expcatfields->get('usecondition')) {
                                $obj->condition = $this->expcheckdb('expautos_condition', (string) $xmlchild[$i]->condition, 'name', 'state', $expparams->get('c_admanager_req_condition'), 1, 0);
                            }
                            if ($expcatfields->get('usebodytype')) {
                                $obj->bodytype = $this->expcheckdb('expautos_bodytype', (string) $xmlchild[$i]->bodytype, 'name', 'state', $expparams->get('c_admanager_req_bodytype'), 1, 0, 'catid = ' . $obj->catid);
                            }
                            if ($expcatfields->get('usedrive')) {
                                $obj->drive = $this->expcheckdb('expautos_drive', (string) $xmlchild[$i]->drive, 'name', 'state', $expparams->get('c_admanager_req_drive'), 1, 0);
                            }
                            if ($expcatfields->get('usefuel')) {
                                $obj->fuel = $this->expcheckdb('expautos_fuel', (string) $xmlchild[$i]->fuel, 'name', 'state', $expparams->get('c_admanager_req_fuel'), 1, 0);
                            }
                            if ($expcatfields->get('usetrans')) {
                                $obj->trans = $this->expcheckdb('expautos_trans', (string) $xmlchild[$i]->trans, 'name', 'state', $expparams->get('c_admanager_req_trans'), 1, 0);
                            }
                            if ($expcatfields->get('useequipment')) {
                                $obj->equipment = $this->expcheckdb_eq((string) $xmlchild[$i]->equipment, $obj->catid);
                            }
                            if ($expcatfields->get('useyear') && (int) $xmlchild[$i]->year) {
                                $mask_year = substr($xmlchild[$i]->year, 0, 4);
                                $obj->year = $mask_year;
                            } elseif ($expcatfields->get('useyear') && $expparams->get('c_admanager_req_year')) {
                                $this->expcheckreq(JText::_('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_YEAR_TEXT'));
                            }
                            if ($expcatfields->get('usemonth') && (int) $xmlchild[$i]->month) {
                                $obj->month = (int) $xmlchild[$i]->month;
                            } elseif ($expcatfields->get('usemonth') && $expparams->get('c_admanager_req_month')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_MONTH_TEXT');
                            }
                            if ($expcatfields->get('usevincode') && (string) $xmlchild[$i]->vincode) {
                                $obj->vincode = strip_tags((string) $xmlchild[$i]->vincode);
                            } elseif ($expcatfields->get('usevincode') && $expparams->get('c_admanager_req_vincode')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_VINCODE_TEXT');
                            }
                            if ($expcatfields->get('usemileage') && (int) $xmlchild[$i]->mileage) {
                                $obj->mileage = (int) $xmlchild[$i]->mileage;
                            } elseif ($expcatfields->get('usemileage') && $expparams->get('c_admanager_req_mileage')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_MILEAGE_TEXT');
                            }
                            if ($expcatfields->get('useprice') && (int) $xmlchild[$i]->price) {
                                $obj->price = (int) $xmlchild[$i]->price;
                            } elseif ($expcatfields->get('useprice') && $expparams->get('c_admanager_req_price')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_PRICE_TEXT');
                            }
                            if ($expcatfields->get('usebprice') && (int) $xmlchild[$i]->bprice) {
                                $obj->bprice = (int) $xmlchild[$i]->bprice;
                            }
                            if ($expcatfields->get('useextcolor')) {
                                $obj->extcolor = $this->expcheckdb('expautos_color', (string) $xmlchild[$i]->extcolor, 'name', 'state', $expparams->get('c_admanager_req_extcolor'), 1, 0);
                            }
                            if ($expcatfields->get('useintcolor')) {
                                $obj->intcolor = $this->expcheckdb('expautos_color', (string) $xmlchild[$i]->intcolor, 'name', 'state', $expparams->get('c_admanager_req_intcolor'), 1, 0);
                            }
                            if ($expcatfields->get('usedoors') && (int) $xmlchild[$i]->doors) {
                                $obj->doors = (int) $xmlchild[$i]->doors;
                            }
                            if ($expcatfields->get('useseats') && (int) $xmlchild[$i]->seats) {
                                $obj->seats = (int) $xmlchild[$i]->seats;
                            }
                            if ($expcatfields->get('useengine') && (int) $xmlchild[$i]->engine) {
                                $obj->engine = (int) $xmlchild[$i]->engine;
                            } elseif ($expcatfields->get('useengine') && $expparams->get('c_admanager_req_engine')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_ENGINE_TEXT');
                            }

                            $expexpirdate = $expreqfield->get('c_adlifeduration');
                            if (!$expexpirdate)
                                $expexpirdate = 30;

                            $offset = $app->getCfg('offset');

                            $dStart = new JDate('now', $offset);
                            $dStart->setTime(0, 0, 0);

                            $tz = new DateTimeZone('GMT');
                            $dStart->setTimezone($tz);
                            $n_creatdate = $dStart->format('Y-m-d H:i:s');
                            $exprdate = $dStart->modify('+ ' . $expexpirdate . 'day');
                            $n_expirdate = $dStart->format('Y-m-d H:i:s');

                            $obj->creatdate = $n_creatdate;
                            $obj->expirdate = $n_expirdate;
                            if ($expcatfields->get('useotherinfo') && (string) $xmlchild[$i]->otherinfo) {
                                $othinfo = substr($xmlchild[$i]->otherinfo, 0, $expparams->get('c_admanager_add_maxotherinfo'));
                                $othinfo = strip_tags(stripslashes($othinfo), '<strong><b><i><p>');
                                $obj->otherinfo = $othinfo;
                            }
                            if ($expcatfields->get('useunweight') && (int) $xmlchild[$i]->unweight) {
                                $obj->unweight = (int) $xmlchild[$i]->unweight;
                            }
                            if ($expcatfields->get('usegrweight') && (int) $xmlchild[$i]->grweight) {
                                $obj->grweight = (int) $xmlchild[$i]->grweight;
                            }
                            if ($expcatfields->get('uselength') && (int) $xmlchild[$i]->length) {
                                $obj->length = (int) $xmlchild[$i]->length;
                            }
                            if ($expcatfields->get('usewidth') && (int) $xmlchild[$i]->width) {
                                $obj->width = (int) $xmlchild[$i]->width;
                            }
                            if ($expcatfields->get('usedisplacement') && (string) $xmlchild[$i]->displacement) {
                                $mask_displ = preg_match('/[\d]\.[\d]/s', $xmlchild[$i]->displacement);
                                if ($mask_displ) {
                                    $obj->displacement = strip_tags((string) $xmlchild[$i]->displacement);
                                }
                            } elseif ($expcatfields->get('usedisplacement') && $expparams->get('c_admanager_req_displacement')) {
                                $this->expcheckreq('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_DISPL_TEXT');
                            }
                            if ($expcatfields->get('embedcode') && (string) $xmlchild[$i]->embedcode) {
                                $obj->embedcode = strip_tags(stripslashes((string) $xmlchild[$i]->embedcode), '<object><param><embed><iframe>');
                            }
                            //$obj->embedcode = '';
                            $obj->fcommercial = 0;
                            $obj->ffeatured = 0;
                            $obj->ftop = 0;
                            $obj->special = 0;
                            $obj->hits = 0;
                            $obj->ordering = 0;
                            $obj->state = $expreqfield->get('g_published');
                            $obj->expemail = 0;
                            if ($expcatfields->get('usemetalliccolor') && $xmlchild[$i]->metalliccolor == 'yes') {
                                $obj->metalliccolor = 1;
                            }
                            if ($expcatfields->get('usespecificcolor') && $xmlchild[$i]->specificcolor) {
                                $scolor = substr($xmlchild[$i]->specificcolor, 0, 50);
                                $scolor = strip_tags($scolor);
                                $obj->specificcolor = $scolor;
                            }
                            if ($expcatfields->get('usespecificmodel') && $xmlchild[$i]->specificmodel) {
                                $smodel = substr($xmlchild[$i]->specificmodel, 0, 50);
                                $smodel = strip_tags($smodel);
                                $obj->specificmodel = $smodel;
                            }
                            if ($expcatfields->get('usespecifictrans') && $xmlchild[$i]->specifictrans) {
                                $strans = substr($xmlchild[$i]->specifictrans, 0, 50);
                                $strans = strip_tags($strans);
                                $obj->specifictrans = $strans;
                            }
                            if ($expcatfields->get('useexpprice') && (int) $xmlchild[$i]->expprice) {
                                $obj->expprice = (int) $xmlchild[$i]->expprice;
                            }
                            if ($expcatfields->get('usefconsum')) {
                                if ((int) $xmlchild[$i]->fconsumcity) {
                                    $obj->fconsumcity = (int) $xmlchild[$i]->fconsumcity;
                                }
                                if ((int) $xmlchild[$i]->fconsumfreeway) {
                                    $obj->fconsumfreeway = (int) $xmlchild[$i]->fconsumfreeway;
                                }
                                if ((int) $xmlchild[$i]->fconsumcombined) {
                                    $obj->fconsumcombined = (int) $xmlchild[$i]->fconsumcombined;
                                }
                            }
                            if ($expcatfields->get('useadacceleration') && (int) $xmlchild[$i]->adacceleration) {
                                $obj->adacceleration = (int) $xmlchild[$i]->adacceleration;
                            }
                            if ($expcatfields->get('usemaxspeed') && (int) $xmlchild[$i]->maxspeed) {
                                $obj->maxspeed = (int) $xmlchild[$i]->maxspeed;
                            }
                            $obj->solid = 0;
                            if ($expcatfields->get('useco') && (int) $xmlchild[$i]->co) {
                                $mask_co = preg_match('/[\d]\.[\d]/s', $xmlchild[$i]->co);
                                if ($mask_co) {
                                    $obj->co = $xmlchild[$i]->co;
                                }
                            }
                            $obj->language = '*';
                            $obj->access = 1;
                            if ($expcatfields->get('useextrafield1')) {
                                $obj->extrafield1 = $this->expcheckdb('expautos_extrafield1', $xmlchild[$i]->extrafield1, 'name', 'state', $expparams->get('c_admanager_req_extrafield1'), 1, 0, 'catid = ' . $obj->catid);
                            }
                            if ($expcatfields->get('useextrafield2')) {
                                $obj->extrafield2 = $this->expcheckdb('expautos_extrafield2', $xmlchild[$i]->extrafield2, 'name', 'state', $expparams->get('c_admanager_req_extrafield2'), 1, 0);
                            }
                            if ($expcatfields->get('useextrafield3')) {
                                $obj->extrafield3 = $this->expcheckdb('expautos_extrafield3', $xmlchild[$i]->extrafield3, 'name', 'state', $expparams->get('c_admanager_req_extrafield3'), 1, 0);
                            }
                            if ($expcatfields->get('usevattext')) {
                                $obj->vattext = strip_tags($xmlchild[$i]->vattext);
                            }
                            if ($expcatfields->get('usestocknum') && $xmlchild[$i]->stocknum) {
                                $sstocknum = substr($xmlchild[$i]->stocknum, 0, 50);
                                $sstocknum = strip_tags($sstocknum);
                                $obj->stocknum = $sstocknum;
                            }
                            if ($expcatfields->get('usestate') && $obj->country) {
                                $obj->expstate = $this->expcheckdb('expautos_state', $xmlchild[$i]->expstate, 'name', 'state', $expparams->get('c_admanager_req_state'), 1, 0, 'catid = ' . $obj->country);
                            }
                            if ($expcatfields->get('usecity') && isset($obj->expstate)) {
                                $obj->city = $this->expcheckdb('expautos_cities', $xmlchild[$i]->city, 'city_name', 'state', $expparams->get('c_admanager_req_city'), 1, 0, 'catid = ' . $obj->expstate);
                            }
                            $obj->expreserved = 0;
                            if ($expcatfields->get('usestreet') && $xmlchild[$i]->street) {
                                $sstreet = substr($xmlchild[$i]->street, 0, 80);
                                $sstreet = strip_tags($sstreet);
                                $obj->street = $sstreet;
                            }
                            if ($expcatfields->get('usegooglemaps') && (string) $xmlchild[$i]->latitude) {
                                $obj->latitude = strip_tags((string) $xmlchild[$i]->latitude);
                            }
                            if ($expcatfields->get('usegooglemaps') && (string) $xmlchild[$i]->longitude) {
                                $obj->longitude = strip_tags((string) $xmlchild[$i]->longitude);
                            }
                            if ($expcatfields->get('usezipcode') && $xmlchild[$i]->zipcode) {
                                $szipcode = substr($xmlchild[$i]->zipcode, 0, 10);
                                $szipcode = strip_tags($szipcode);
                                $obj->zipcode = $szipcode;
                            }


                            $imgcat = null;
                            $array_img = null;
                            $countimg = count($xmlchild[$i]->images->children());

                            if ($countimg && $expparams->get('c_admanager_importxml_enableimg', 1) && (($isxml && $expparams->get('c_admanager_importxml_enableimgurl', 0) || !$isxml))) {
                                $countimg = $expreqfield->get('g_imgcount');
                                $img_val = $xmlchild[$i]->images->children();
                                $array_img = array();
                                $img_return = null;
                                foreach ($img_val as $key => $value) {
                                    $config = $expparams;
                                    if ($isxml) {
                                        $file = (string) $value->name;
                                    } else {
                                        $file = $ziparchive['folder'] . "/" . (string) $value->name;
                                    }
                                    $imgcat = (int) $value->catid;
                                    $size = getimagesize($file);
                                    $type = $size['mime'];
                                    $tmpname = basename($file);
                                    //$tmpname = $fl['tmp_name'];
                                    $urlimg = parse_url($file, PHP_URL_HOST);
                                    if ($urlimg) {
                                        $urlimg = str_replace(".", "_", $urlimg);
                                        $urlimg = "_" . $urlimg;
                                    } else {
                                        $urlimg = $userId;
                                    }
                                    $sufix = mt_rand();
                                    $img_name = explode(".", strtolower($file));
                                    $img_name = end($img_name);
                                    $respons_img = $sufix . $urlimg . "." . $img_name;
                                    $input_file = $file;
                                    //$input_file = base64_decode($input_file);
                                    $output_tmbfile = ExpAutosProExpparams::ImgAbsPathThumbs() . $respons_img;
                                    $output_middlefile = ExpAutosProExpparams::ImgAbsPathMiddle() . $respons_img;
                                    $output_bigfile = ExpAutosProExpparams::ImgAbsPathBig() . $respons_img;
                                    $options_tmbfile = array(
                                        'width' => $config->get('c_images_thumbsize_width'),
                                        'height' => $config->get('c_images_thumbsize_height'),
                                        'method' => $config->get('c_images_resmethod'),
                                        'percent' => $config->get('c_images_percent'),
                                        'halign' => $config->get('c_images_horalign'),
                                        'valign' => $config->get('c_images_vertalign'),
                                        'watermark' => 0,
                                    );
                                    $options_middlefile = array(
                                        'width' => $config->get('c_images_middlesize_width'),
                                        'height' => $config->get('c_images_middlesize_height'),
                                        'method' => $config->get('c_images_resmethod'),
                                        'percent' => $config->get('c_images_percent'),
                                        'halign' => $config->get('c_images_horalign'),
                                        'valign' => $config->get('c_images_vertalign'),
                                        'watermark' => $config->get('c_images_wt_use'),
                                    );
                                    $img_return = ExpAutosProExpparams::output($input_file, $output_tmbfile, $options_tmbfile);
                                    $img_return = ExpAutosProExpparams::output($input_file, $output_middlefile, $options_middlefile);

                                    if ($config->get('c_images_maxsize_width') == 0 && $config->get('c_images_maxsize_height') == 0 || $size[0] < $config->get('c_images_maxsize_width') || $size[1] < $config->get('c_images_maxsize_height')) {
                                        if (true) {
                                            $options_bigfile = array(
                                                'percent' => 0,
                                                'method' => $config->get('c_images_resmethod'),
                                                'width' => $size[0],
                                                'height' => $size[1],
                                                'halign' => 0,
                                                'valign' => 0,
                                                'watermark' => $config->get('c_images_wt_use'),
                                            );
                                            $img_return = ExpAutosProExpparams::output($input_file, $output_bigfile, $options_bigfile);
                                        } else {
                                            move_uploaded_file($input_file, $output_bigfile);
                                        }
                                    } else {

                                        $options_bigfile = array(
                                            'percent' => $config->get('c_images_percent'),
                                            'method' => $config->get('c_images_resmethod'),
                                            'width' => $config->get('c_images_maxsize_width'),
                                            'height' => $config->get('c_images_maxsize_height'),
                                            'halign' => $config->get('c_images_horalign'),
                                            'valign' => $config->get('c_images_vertalign'),
                                            'watermark' => $config->get('c_images_wt_use'),
                                        );
                                        $img_return = ExpAutosProExpparams::output($input_file, $output_bigfile, $options_bigfile);
                                    }
                                    if ($img_return) {
                                        $array_img[] = array('image_name' => $respons_img, 'image_ordering' => (int) $value->ordering, 'image_description' => strip_tags((string) $value->description));
                                    }
                                }
                            }
                        }


                        if (!$this->getError()) {
                            $db->insertObject('#__expautos_admanager', $obj);
                            $table_id = null;
                            if ($expparams->get('c_admanager_importxml_enableimg', 0) && is_array($array_img)) {
                                $table_id = $db->insertid();
                                $array_img['id'] = $table_id;
                                $newarray[] = $array_img;
                            }
                        }
                        /*
                          print_r($this->getError());
                          echo "<br /><br /><br /><br />";
                          print_r($obj);
                         * 
                         */
                    }
                    if ($zipfolder && $zipname) {
                        JInstallerHelper::cleanupInstall($zipname, $zipfolder);
                    }

                    if (is_array($newarray)) {
                        foreach ($newarray as $key => $value) {
                            foreach ($value as $val) {
                                if ($val['image_name']) {
                                    $objimg = new stdClass();
                                    $objimg->catid = (int) $value['id'];
                                    $objimg->name = $val['image_name'];
                                    $objimg->ordering = $val['image_ordering'];
                                    $objimg->description = $val['image_description'];
                                    $db->insertObject('#__expautos_images', $objimg);
                                }
                            }

                            ExpAutosProHelper::getExpdataImg($value['id']);
                        }
                    }
                    return true;
                } else {
                    if ($zipfolder && $zipname) {
                        JInstallerHelper::cleanupInstall($zipname, $zipfolder);
                    }
                    $app->enqueueMessage(JText::_('COM_EXPAUTOSPRO_IMPORTXML_ERROR_ZIPARCHIVE_TEXT'), 'warning');
                    return false;
                }
            } else {
                $app->enqueueMessage(JText::_('COM_EXPAUTOSPRO_IMPORTXML_ERROR_XML_NAME_TEXT'), 'warning');
                return false;
            }
        } else {
            $app->enqueueMessage(JText::_('COM_EXPAUTOSPRO_CP_EXPIMPORT_NOLEVELS_TEXT'), 'warning');
            return false;
        }
    }

    protected function _getPackageFromUpload($userfiles) {
        jimport('joomla.filesystem.archive');
        jimport('joomla.filesystem.file');
        $result_pack = null;
        $findxml = null;
        $userfile = $userfiles;

        if (!(bool) ini_get('file_uploads')) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLFILE'));
            return false;
        }

        if (!extension_loaded('zlib')) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLZLIB'));
            return false;
        }

        if (!is_array($userfile)) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_NO_FILE_SELECTED'));
            return false;
        }

        if ($userfile['error'] || $userfile['size'] < 1) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLUPLOADERROR'));
            return false;
        }

        $config = JFactory::getConfig();
        $tmp_dest = $config->get('tmp_path') . '/' . $userfile['name'];
        $tmp_src = $userfile['tmp_name'];

        $uploaded = JFile::upload($tmp_src, $tmp_dest);
        $tmpdir = uniqid('expimport_');

        $extractdir = JPath::clean(dirname($tmp_dest) . '/' . $tmpdir);
        $archivename = JPath::clean($tmp_dest);
        $extract_ar = JArchive::extract($tmp_dest, $extractdir);
        if ($extract_ar) {
            $findxml = JFolder::files($extractdir, '.xml$', false, false);
        }
        if ($findxml) {
            $result_pack = array('folder' => $extractdir, 'file' => $findxml[0], 'zipname' => $archivename);
        } else {
            JInstallerHelper::cleanupInstall($archivename, $extractdir);
        }
        return $result_pack;
    }

    public function expcheckreq($name) {
        $app = JFactory::getApplication();
        $app->enqueueMessage(JText::sprintf(JText::_('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_REQ_TEXT'), $name), 'warning');
        return false;
    }

    public function expcheckdb($dbname, $strtext, $field_name = 'name', $publ_text = 'state', $req, $publ = 1, $extension = 0, $where = '') {
        $app = JFactory::getApplication();
        $model = JModelLegacy::getInstance('ExpImport', 'ExpAutosProModel', array('ignore_request' => true));
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('id');
        $query->from('#__' . $dbname);
        if ($extension) {
            $query->where('extension LIKE ' . $db->Quote('com_expautospro'));
        }
        $query->where($field_name . ' LIKE ' . $db->Quote($strtext));
        if ($publ) {
            $query->where($publ_text . ' = 1');
        }
        if ($where) {
            $query->where($where);
        }
        $db->setQuery($query);
        $result = $db->loadResult();
        if (!$result && $req) {
            $this->setError(1);
            $app->enqueueMessage(JText::sprintf(JText::_('COM_EXPAUTOSPRO_CP_EXPIMPORT_ERROR_' . $dbname . '_TEXT'), $strtext), 'warning');
            return false;
        } else {
            return $result;
        }
    }

    public function expcheckdb_eq($value, $catid, $publ = 1) {
        $app = JFactory::getApplication();
        $db = JFactory::getDBO();
        $comma_separated = explode(",", $value);
        $query = $db->getQuery(true);
        $query->select('id');
        $query->from('#__expautos_catequipment');
        $query->where('catid = ' . $catid);
        if ($publ) {
            $query->where('state = 1');
        }
        $db->setQuery($query);
        $catresult = $db->loadResultArray();
        $result = array();
        if ($catresult) {
            $catresult = implode(",", $catresult);
            foreach ($comma_separated as $key => $val) {
                $val = trim($val);
                $query = $db->getQuery(true);
                $query->select('id');
                $query->from('#__expautos_equipment');
                $query->where('catid IN (' . $catresult . ')');
                $query->where('name LIKE ' . $db->Quote($val));
                if ($publ) {
                    $query->where('state = 1');
                }
                $db->setQuery($query);
                if ($db->loadResult()) {
                    $result[] = $db->loadResult();
                }
            }
        }
        $expl = implode(",", $result);
        return $expl;
    }

    function GetFileData($sFilePath) {
        $fp = fopen($sFilePath, 'rb') or die('404! Unable to open file!');
        $buf = '';
        while (!feof($fp)) {
            $buf .= fgets($fp, 4096);
        }
        fclose($fp);
        return $buf; //returns False if failed, else the contents up to FileSize bytes.
    }

    public function getExpItemid() {
        $expitemid = ExpAutosProExpparams::getExpLinkItemid();
        return $expitemid;
    }

}

